Index: src/edu/ucsb/nceas/metacat/MetaCatServlet.java
===================================================================
--- src/edu/ucsb/nceas/metacat/MetaCatServlet.java	(revision 1216)
+++ src/edu/ucsb/nceas/metacat/MetaCatServlet.java	(revision 1217)
@@ -105,7 +105,6 @@
 
   private ServletConfig config = null;
   private ServletContext context = null;
-  //private Hashtable connectionPool = new Hashtable();
   private String resultStyleURL = null;
   private String xmlcatalogfile = null;
   private String saxparser = null;
@@ -115,6 +114,7 @@
   private String htmlpath = null; 
   private PropertyResourceBundle options = null;
   private MetaCatUtil util = null;
+  private DBConnectionPool connPool = null;
 
   /**
    * Initialize the servlet by creating appropriate database connections
@@ -127,6 +127,9 @@
       System.out.println("MetaCatServlet Initialize");
 
       util = new MetaCatUtil();
+      
+      //initial DBConnection pool
+      connPool = DBConnectionPool.getInstance();
 
       // Get the configuration file information
       resultStyleURL = util.getOption("resultStyleURL");
@@ -137,16 +140,12 @@
       servletpath = util.getOption("servletpath");
       htmlpath = util.getOption("htmlpath");
 
-// MOVED IT TO doGet() & doPost()
-//      try {
-//        // Open a pool of db connections
-//        connectionPool = util.getConnectionPool();
-//      } catch (Exception e) {
-//        System.err.println("Error creating pool of database connections");
-//        System.err.println(e.getMessage());
-//      }
+
     } catch ( ServletException ex ) {
       throw ex;
+    } catch (SQLException e) {
+      MetaCatUtil.debugMessage("Error in MetacatServlet.init: "
+                                          +e.getMessage(), 20);
     }
   }
 
@@ -154,10 +153,8 @@
    * Close all db connections from the pool
    */
   public void destroy() {
-    
-    if (util != null) {
-        util.closeConnections();
-    }
+      // Close all db connection  
+      connPool.release();
   }
 
   /** Handle "GET" method requests from HTTP clients */
@@ -187,23 +184,13 @@
     if ( util == null ) {
         util = new MetaCatUtil(); 
     }
-    util.debugMessage("Connection pool size: "+util.getPoolSize(),1);
-    /*if ( connectionPool.isEmpty() ) {
-      try {
-       
-        connectionPool = util.getConnectionPool();
-      } catch (Exception e) {
-        System.err.println("Error creating pool of database connections in " +
-                            " MetaCatServlet.handleGetOrPost");
-        System.err.println(e.getMessage());
-      }
-    } */   
-    // Get a handle to the output stream back to the client
-    //PrintWriter pwout = response.getWriter();
-    //response.setContentType("text/html");
-
-    // Deal with forms that are encoded as "multipart/form-data" differently
-    // this is mainly used for uploading non-xml files using that may be binary
+    MetaCatUtil.debugMessage("Connection pool size: "
+                                     +connPool.getSizeOfDBConnectionPool(),10);
+    MetaCatUtil.debugMessage("Free DBConnection number: "
+                                     +connPool.getFreeDBConnectionNumber(), 10);
+    //Debug message to print out the method which have a busy DBConnection
+    connPool.printMethodNameHavingBusyDBConnection();
+   
     String ctype = request.getContentType();
     if (ctype != null && ctype.startsWith("multipart/form-data")) {
       handleMultipartForm(request, response);
@@ -215,7 +202,10 @@
       String[] docid = new String[3];
       Hashtable params = new Hashtable();
       Enumeration paramlist = request.getParameterNames();
+     
+    
       while (paramlist.hasMoreElements()) {
+      
         name = (String)paramlist.nextElement();
         value = request.getParameterValues(name);
   
@@ -232,10 +222,16 @@
         params.put(name,value); 
       }  
       
+    
+      //handle param is emptpy
+      if (params.isEmpty() || params == null)
+      {
+        return;
+      }
       //if the user clicked on the input images, decode which image
       //was clicked then set the action.
       String action = ((String[])params.get("action"))[0];  
-      util.debugMessage("Line 213: Action is: " + action, 1);
+      util.debugMessage("Line 230: Action is: " + action, 1);
   
       // This block handles session management for the servlet
       // by looking up the current session information for all actions
@@ -247,14 +243,16 @@
   
       // handle login action
       if (action.equals("login")) {
+        PrintWriter out = response.getWriter();
+        handleLoginAction(out, params, request, response);
+        out.close();
   
-        handleLoginAction(response.getWriter(), params, request, response);
-  
       // handle logout action  
       } else if (action.equals("logout")) {
+        PrintWriter out = response.getWriter();
+        handleLogoutAction(out, params, request, response);
+        out.close();
   
-        handleLogoutAction(response.getWriter(), params, request, response);
-  
       // aware of session expiration on every request  
       } else {   
   
@@ -280,13 +278,17 @@
        // Now that we know the session is valid, we can delegate the request
       // to a particular action handler
       if(action.equals("query")) {
-        handleQuery(response.getWriter(),params,response,username,groupnames);
+        PrintWriter out = response.getWriter();
+        handleQuery(out,params,response,username,groupnames);
+        out.close();
       } else if(action.equals("squery")) {
+        PrintWriter out = response.getWriter();
         if(params.containsKey("query")) {
-         handleSQuery(response.getWriter(),params,response,username,groupnames); 
+         handleSQuery(out, params,response,username,groupnames);
+         out.close();
         } else {
-          PrintWriter out = response.getWriter();
           out.println("Illegal action squery without \"query\" parameter");
+          out.close();
         }
       } else if (action.equals("export")) {
         
@@ -299,7 +301,8 @@
           handleInsertOrUpdateAction(out,params,response,username,groupnames);
         } else {  
           out.println("Permission denied for " + action);
-        }  
+        }
+        out.close();
       } else if (action.equals("delete")) {
         PrintWriter out = response.getWriter();
         if ( (username != null) &&  !username.equals("public") ) {
@@ -306,28 +309,36 @@
           handleDeleteAction(out, params, response, username, groupnames);
         } else {  
           out.println("Permission denied for " + action);
-        }  
+        }
+        out.close();
       } else if (action.equals("validate")) {
         PrintWriter out = response.getWriter();
-        handleValidateAction(out, params, response); 
+        handleValidateAction(out, params, response);
+        out.close();
       } else if (action.equals("getaccesscontrol")) {
         PrintWriter out = response.getWriter();
         handleGetAccessControlAction(out,params,response,username,groupnames);
+        out.close();
       } else if (action.equals("getprincipals")) {
         PrintWriter out = response.getWriter();
-        handleGetPrincipalsAction(out, username, password);  
+        handleGetPrincipalsAction(out, username, password);
+        out.close();
       } else if (action.equals("getdoctypes")) {
         PrintWriter out = response.getWriter();
-        handleGetDoctypesAction(out, params, response);  
+        handleGetDoctypesAction(out, params, response);
+        out.close();
       } else if (action.equals("getdtdschema")) {
         PrintWriter out = response.getWriter();
-        handleGetDTDSchemaAction(out, params, response);  
+        handleGetDTDSchemaAction(out, params, response);
+        out.close();
       } else if (action.equals("getdataguide")) {
         PrintWriter out = response.getWriter();
-        handleGetDataGuideAction(out, params, response);  
+        handleGetDataGuideAction(out, params, response);
+        out.close();
       } else if (action.equals("getlastdocid")) {
         PrintWriter out = response.getWriter();
-        handleGetMaxDocidAction(out, params, response);  
+        handleGetMaxDocidAction(out, params, response);
+        out.close();
       } else if (action.equals("login") || action.equals("logout")) {
       } else if (action.equals("protocoltest")) {
         String testURL = "metacat://dev.nceas.ucsb.edu/NCEAS.897766.9";
@@ -376,11 +387,12 @@
         out.println("<error>");
         out.println("Error: action not registered.  Please report this error.");
         out.println("</error>");
+        out.close();
       }
       
-      util.closeConnections();
+      //util.closeConnections();
       // Close the stream to the client
-      // out.close();
+      //out.close();
     }
   }
   
@@ -412,16 +424,18 @@
       response.setContentType("text/xml");
       out.println(sess.getMessage()); 
     } else {
-      Connection conn = null;
+     
       try {
-        conn = util.getConnection();
-        DBTransform trans = new DBTransform(conn);
+        
+        DBTransform trans = new DBTransform();
         response.setContentType("text/html");
         trans.transformXMLDocument(sess.getMessage(), "-//NCEAS//login//EN",
                                    "-//W3C//HTML//EN", qformat, out);
-        util.returnConnection(conn); 
+         
       } catch(Exception e) {
-        util.returnConnection(conn); 
+        
+        MetaCatUtil.debugMessage("Error in MetaCatServlet.handleLoginAction: "
+                                +e.getMessage(), 30);
       } 
       
     // any output is returned  
@@ -452,16 +466,18 @@
       response.setContentType("text/xml");
       out.println(output.toString()); 
     } else {
-      Connection conn = null;
+      
       try {
-        conn = util.getConnection();
-        DBTransform trans = new DBTransform(conn);
+       
+        DBTransform trans = new DBTransform();
         response.setContentType("text/html");
         trans.transformXMLDocument(output.toString(), "-//NCEAS//login//EN", 
                                    "-//W3C//HTML//EN", qformat, out);
-        util.returnConnection(conn); 
+         
       } catch(Exception e) {
-        util.returnConnection(conn); 
+        
+        MetaCatUtil.debugMessage("Error in MetaCatServlet.handleLogoutAction"
+                                  +e.getMessage(), 30);
       } 
     }
   }
@@ -566,19 +582,20 @@
   private Hashtable runQuery(String xmlquery, String user, String[] groups)
   {
     Hashtable doclist=null;
-    Connection conn = null;
+  
     try
     {
-      conn = util.getConnection();
-      DBQuery queryobj = new DBQuery(conn, saxparser);
+    
+      DBQuery queryobj = new DBQuery(saxparser);
       doclist = queryobj.findDocuments(new StringReader(xmlquery),user,groups);
-      util.returnConnection(conn);
+ 
       return doclist;
     } 
     catch (Exception e) 
     {
-      util.returnConnection(conn); 
-      util.debugMessage("Error in MetacatServlet.runQuery: " + e.getMessage());
+    
+      MetaCatUtil.debugMessage("Error in MetacatServlet.runQuery: " 
+                                                      + e.getMessage(), 30);
       doclist = null;
       return doclist;
     }    
@@ -597,18 +614,20 @@
                                     HttpServletResponse response,
                                     PrintWriter out, String qformat)
   {
-    Connection conn = null;
+  
     try {
-      conn = util.getConnection();
-      DBTransform trans = new DBTransform(conn);
+     
+      DBTransform trans = new DBTransform();
       response.setContentType("text/html");
       trans.transformXMLDocument(resultdoc, "-//NCEAS//resultset//EN", 
                                  "-//W3C//HTML//EN", qformat, out);
-      util.returnConnection(conn); 
+     
     }
     catch(Exception e)
     {
-      util.returnConnection(conn); 
+      
+      MetaCatUtil.debugMessage("Error in MetaCatServlet.transformResultset:"
+                                +e.getMessage(), 30);
     } 
   }
   
@@ -662,7 +681,7 @@
     ZipOutputStream zOut = null;
     DocumentImpl docImpls=null;
     DBQuery queryObj=null;
-    Connection conn = null;
+  
     String[] docs = new String[10];
     String docId = "";
 
@@ -673,9 +692,8 @@
         docs = (String[])params.get("docid");
       }
 
-      //get the connection to database
-      conn = util.getConnection();
-      queryObj = new DBQuery(conn, saxparser);//"saxparser" have to use though
+   
+      queryObj = new DBQuery(saxparser);//"saxparser" have to use though
                                               //it is not standard
       docId=docs[0];
       out = response.getOutputStream();
@@ -708,21 +726,18 @@
       }
       catch (IOException ioe)
       {
-        util.debugMessage("Problem with the servlet output " +
+        MetaCatUtil.debugMessage("Problem with the servlet output " +
                            "in MetacatServlet.handleReadAction: " +
-                           ioe.getMessage());
+                           ioe.getMessage(), 30);
         
 
       }
 
-      util.debugMessage("Error in MetacatServlet.handleReadAction: " +
-                         e.getMessage());
+      MetaCatUtil.debugMessage("Error in MetacatServlet.handleReadAction: " +
+                         e.getMessage(), 30);
       
     }//catch
-    finally 
-    {
-      util.returnConnection(conn);
-    }
+   
 
   }//handleExportAction
   
@@ -853,17 +868,18 @@
                throws ClassNotFoundException, IOException, SQLException, 
                       McdbException, Exception
   {
-    Connection conn = null;
+   
     try {
-      conn = util.getConnection();
-      DocumentImpl doc = new DocumentImpl(conn, docid);
+     
       
+      DocumentImpl doc = new DocumentImpl(docid);
+    
       //check the permission for read
-      if (!doc.hasReadPermission(conn, user, groups, docid))
+      if (!doc.hasReadPermission(user, groups, docid))
       {
         Exception e = new Exception("User " + user + " does not have permission"
                        +" to read the document with the docid " + docid);
-        util.returnConnection(conn);
+    
         throw e;
       }
      
@@ -915,6 +931,7 @@
       } else {
         // this is metadata doc
         if ( qformat.equals("xml") ) { 
+          
           // set content type first
           response.setContentType("text/xml");   //MIME type
           PrintWriter out = response.getWriter();
@@ -926,14 +943,15 @@
           // Look up the document type
           String doctype = doc.getDoctype();
           // Transform the document to the new doctype
-          DBTransform dbt = new DBTransform(conn);
+          DBTransform dbt = new DBTransform();
           dbt.transformXMLDocument(doc.toString(),
                                    doctype,"-//W3C//HTML//EN", qformat, out);
         }
       
       }
-    } finally {
-      util.returnConnection(conn);
+    } catch (Exception except) {
+      throw except;
+    
     }
     
   }
@@ -1017,17 +1035,17 @@
     } catch (MalformedURLException mue) {
       
       // this is metacat doc (data file or metadata doc)
-      Connection conn = null;
+  
       try {
-        conn = util.getConnection();
-        DocumentImpl doc = new DocumentImpl(conn, docid);
+       
+        DocumentImpl doc = new DocumentImpl(docid);
         
         //check the permission for read
-        if (!doc.hasReadPermission(conn, user, groups, docid))
+        if (!doc.hasReadPermission(user, groups, docid))
         {
           Exception e = new Exception("User " + user + " does not have "
                     +"permission to read the document with the docid " + docid);
-          util.returnConnection(conn);
+        
           throw e;
         } 
         
@@ -1063,8 +1081,9 @@
           zout.write(bytestring, 0, bytestring.length);
           zout.closeEntry();
         }
-      } finally {
-        util.returnConnection(conn);
+      } catch (Exception except) {
+        throw except;
+       
       }
       
     }
@@ -1077,14 +1096,13 @@
                throws ClassNotFoundException, IOException, SQLException,
                       McdbException, Exception
   {
-    Connection conn = null;
+  
+    PrintWriter out =null;
     try {
-      conn = util.getConnection();
-    
-      Object[] abstracts = DBQuery.getNodeContent(abstractpath, docid, conn);
-    
+   
       response.setContentType("text/html");  //MIME type
-      PrintWriter out = response.getWriter();
+      out = response.getWriter();
+      Object[] abstracts = DBQuery.getNodeContent(abstractpath, docid);
       out.println("<html><head><title>Abstract</title></head>");
       out.println("<body bgcolor=\"white\"><h1>Abstract</h1>");
       for (int i=0; i<abstracts.length; i++) {
@@ -1092,8 +1110,13 @@
       }
       out.println("</body></html>");
 
-    } finally {
-      util.returnConnection(conn);
+    } catch (Exception e) {
+       out.println("<?xml version=\"1.0\"?>");
+       out.println("<error>");
+       out.println(e.getMessage());
+       out.println("</error>");
+    
+   
     }
   }
   // END OF READ SECTION
@@ -1106,7 +1129,8 @@
   private void handleInsertOrUpdateAction(PrintWriter out, Hashtable params, 
                HttpServletResponse response, String user, String[] groups) {
 
-    Connection conn = null;
+    DBConnection dbConn = null;
+    int serialNumber = -1;
 
     try {
       // Get the document indicated
@@ -1145,25 +1169,36 @@
         } else if (action[0].equals("update")) {
           doAction = "UPDATE";
         }
-
-        try {
+        
+        try 
+        {
           // get a connection from the pool
-          conn = util.getConnection();
-
+          dbConn=DBConnectionPool.
+                  getDBConnection("MetaCatServlet.handleInsertOrUpdateAction");
+          serialNumber=dbConn.getCheckOutSerialNumber();
+          
           // write the document to the database
-          try {
+          try 
+          {
             String accNumber = docid[0];
-            if (accNumber.equals("")) {
+            if (accNumber.equals("")) 
+            {
               accNumber = null;
-            }
-            newdocid = DocumentImpl.write(conn, xml, pub, dtd, doAction,
+            }//if
+            newdocid = DocumentImpl.write(dbConn, xml, pub, dtd, doAction,
                                           accNumber, user, groups, validate);
-          } catch (NullPointerException npe) {
-            newdocid = DocumentImpl.write(conn, xml, pub, dtd, doAction,
+            
+          }//try 
+          catch (NullPointerException npe) 
+          {
+            newdocid = DocumentImpl.write(dbConn, xml, pub, dtd, doAction,
                                           null, user, groups, validate);
-          }
-        } finally {
-          util.returnConnection(conn);
+          }//catch
+        }//try 
+        finally 
+        {
+          // Return db connection
+          DBConnectionPool.returnDBConnection(dbConn, serialNumber);
         }    
 
         // set content type and other response header fields first
@@ -1272,17 +1307,15 @@
                HttpServletResponse response, String user, String[] groups) {
 
     String[] docid = (String[])params.get("docid");
-    Connection conn = null;
-
+  
     // delete the document from the database
     try {
-      // get a connection from the pool
-      conn = util.getConnection();
+ 
                                       // NOTE -- NEED TO TEST HERE
                                       // FOR EXISTENCE OF DOCID PARAM
                                       // BEFORE ACCESSING ARRAY
       try { 
-        DocumentImpl.delete(conn, docid[0], user, groups);
+        DocumentImpl.delete(docid[0], user, groups);
         response.setContentType("text/xml");
         out.println("<?xml version=\"1.0\"?>");
         out.println("<success>");
@@ -1302,9 +1335,7 @@
       out.println("<error>");
       out.println(e.getMessage()); 
       out.println("</error>");
-    } finally {
-      util.returnConnection(conn);
-    }  
+    } 
   }
   // END OF DELETE SECTION
   
@@ -1317,42 +1348,42 @@
 
     // Get the document indicated
     String valtext = null;
+    DBConnection dbConn = null;
+    int serialNumber = -1;
     
     try {
       valtext = ((String[])params.get("valtext"))[0];
     } catch (Exception nullpe) {
 
-      Connection conn = null;
+     
       String docid = null;
       try {
         // Find the document id number
         docid = ((String[])params.get("docid"))[0]; 
 
-        // get a connection from the pool
-        conn = util.getConnection();
-
+      
         // Get the document indicated from the db
-        DocumentImpl xmldoc = new DocumentImpl(conn, docid);
+        DocumentImpl xmldoc = new DocumentImpl(docid);
         valtext = xmldoc.toString();
 
       } catch (NullPointerException npe) {
         response.setContentType("text/xml");
         out.println("<error>Error getting document ID: " + docid + "</error>");
-        if ( conn != null ) { util.returnConnection(conn); }
+        //if ( conn != null ) { util.returnConnection(conn); }
         return;
       } catch (Exception e) {
         response.setContentType("text/html");
         out.println(e.getMessage()); 
-      } finally {
-        util.returnConnection(conn);
-      }  
+      } 
     }
 
-    Connection conn = null;
+  
     try {
       // get a connection from the pool
-      conn = util.getConnection();
-      DBValidate valobj = new DBValidate(saxparser,conn);
+      dbConn=DBConnectionPool.
+                  getDBConnection("MetaCatServlet.handleValidateAction");
+      serialNumber=dbConn.getCheckOutSerialNumber();
+      DBValidate valobj = new DBValidate(saxparser,dbConn);
       boolean valid = valobj.validateString(valtext);
 
       // set content type and other response header fields first
@@ -1367,7 +1398,8 @@
       response.setContentType("text/html");
       out.println(e.getMessage()); 
     } finally {
-      util.returnConnection(conn);
+      // Return db connection
+      DBConnectionPool.returnDBConnection(dbConn, serialNumber);
     }  
   }
   // END OF VALIDATE SECTION
@@ -1382,14 +1414,17 @@
                                        HttpServletResponse response, 
                                        String username, String[] groupnames) {
 
-    Connection conn = null;
+    DBConnection dbConn = null;
+    int serialNumber = -1;
     String docid = ((String[])params.get("docid"))[0];
     
     try {
 
         // get connection from the pool
-        conn = util.getConnection();
-        AccessControlList aclobj = new AccessControlList(conn);
+        dbConn=DBConnectionPool.
+                 getDBConnection("MetaCatServlet.handleGetAccessControlAction");
+        serialNumber=dbConn.getCheckOutSerialNumber();
+        AccessControlList aclobj = new AccessControlList(dbConn);
         String acltext = aclobj.getACL(docid, username, groupnames);
         out.println(acltext);
 
@@ -1399,7 +1434,8 @@
       out.println(e.getMessage());
       out.println("</error>");
     } finally {
-      util.returnConnection(conn);
+      // Retrun db connection to pool
+      DBConnectionPool.returnDBConnection(dbConn, serialNumber);
     }  
     
   }
@@ -1411,11 +1447,10 @@
   private void handleGetPrincipalsAction(PrintWriter out, String user,
                                          String password) {
 
-    Connection conn = null;
-
+   
     try {
 
-        // get connection from the pool
+        
         AuthSession auth = new AuthSession();
         String principals = auth.getPrincipals(user, password);
         out.println(principals);
@@ -1425,9 +1460,7 @@
       out.println("<error>");
       out.println(e.getMessage());
       out.println("</error>");
-    } finally {
-      util.returnConnection(conn);
-    }  
+    } 
     
   }
 
@@ -1438,13 +1471,11 @@
   private void handleGetDoctypesAction(PrintWriter out, Hashtable params, 
                                        HttpServletResponse response) {
 
-    Connection conn = null;
-    
+   
     try {
 
-        // get connection from the pool
-        conn = util.getConnection();
-        DBUtil dbutil = new DBUtil(conn);
+     
+        DBUtil dbutil = new DBUtil();
         String doctypes = dbutil.readDoctypes();
         out.println(doctypes);
 
@@ -1453,9 +1484,7 @@
       out.println("<error>");
       out.println(e.getMessage());
       out.println("</error>");
-    } finally {
-      util.returnConnection(conn);
-    }  
+    } 
     
   }
 
@@ -1466,7 +1495,7 @@
   private void handleGetDTDSchemaAction(PrintWriter out, Hashtable params,
                                         HttpServletResponse response) {
 
-    Connection conn = null;
+   
     String doctype = null;
     String[] doctypeArr = (String[])params.get("doctype");
 
@@ -1478,9 +1507,8 @@
 
     try {
 
-        // get connection from the pool
-        conn = util.getConnection();
-        DBUtil dbutil = new DBUtil(conn);
+       
+        DBUtil dbutil = new DBUtil();
         String dtdschema = dbutil.readDTDSchema(doctype);
         out.println(dtdschema);
 
@@ -1489,9 +1517,7 @@
       out.println("<error>");
       out.println(e.getMessage());
       out.println("</error>");
-    } finally {
-      util.returnConnection(conn);
-    }  
+    } 
     
   }
 
@@ -1502,7 +1528,7 @@
   private void handleGetDataGuideAction(PrintWriter out, Hashtable params, 
                                         HttpServletResponse response) {
 
-    Connection conn = null;
+  
     String doctype = null;
     String[] doctypeArr = (String[])params.get("doctype");
 
@@ -1514,9 +1540,8 @@
 
     try {
 
-        // get connection from the pool
-        conn = util.getConnection();
-        DBUtil dbutil = new DBUtil(conn);
+  
+        DBUtil dbutil = new DBUtil();
         String dataguide = dbutil.readDataGuide(doctype);
         out.println(dataguide);
 
@@ -1525,9 +1550,7 @@
       out.println("<error>");
       out.println(e.getMessage());
       out.println("</error>");
-    } finally {
-      util.returnConnection(conn);
-    }  
+    }
     
   }
 
@@ -1538,7 +1561,7 @@
   private void handleGetMaxDocidAction(PrintWriter out, Hashtable params, 
                                         HttpServletResponse response) {
 
-    Connection conn = null;
+
     String scope = ((String[])params.get("scope"))[0];
     if (scope == null) {
         scope = ((String[])params.get("username"))[0];
@@ -1546,9 +1569,8 @@
 
     try {
 
-        // get connection from the pool
-        conn = util.getConnection();
-        DBUtil dbutil = new DBUtil(conn);
+       
+        DBUtil dbutil = new DBUtil();
         String lastDocid = dbutil.getMaxDocid(scope);
         out.println("<?xml version=\"1.0\"?>");
         out.println("<lastDocid>");
@@ -1561,9 +1583,7 @@
       out.println("<error>");
       out.println(e.getMessage());
       out.println("</error>");
-    } finally {
-      util.returnConnection(conn);
-    }  
+    }
     
   }
 
@@ -1674,6 +1694,7 @@
       out.println("Error: action not registered.  Please report this error.");
       out.println("</error>");
     }
+    out.close();
   }
 
   /** 
@@ -1686,7 +1707,7 @@
                                   String username, String[] groupnames)
   {
     PrintWriter out = null;
-    Connection conn = null;
+    //Connection conn = null;
     String action = null;
     String docid = null;
   
@@ -1734,10 +1755,10 @@
                 // force replcation data file if metacat was configured
                 if (ReplicationHandler.getServerLocation(docid)==1)
                 {//local host document
-                  conn=util.getConnection();
+                  //conn=util.getConnection();
                   ForceReplicationHandler frh = new ForceReplicationHandler
-             (docid, "insert", false, ReplicationHandler.buildServerList(conn));
-                  conn.close();
+             (docid, "insert", false, ReplicationHandler.buildServerList());
+                  //conn.close();
                 }//if
                 else
                 {
@@ -1745,8 +1766,8 @@
                   if ((util.getOption("hub")).equals("super"))
                   {
                     ForceReplicationHandler frh = new ForceReplicationHandler
-                    (docid,true, ReplicationHandler.buildServerList(conn));
-                    conn.close();
+                    (docid,true, ReplicationHandler.buildServerList());
+                    //conn.close();
                   }//if
                   else
                   {
@@ -1773,15 +1794,7 @@
           out.println(e.getMessage()); 
           out.println("</error>");
         }
-        finally
-        {
-          try
-          {
-            conn.close();
-          }
-          catch (SQLException ee)
-          {}
-         }
+       
       }
       else 
       {
